<template>
    <div>
        <div v-if="isLoading">Loading ......</div>
        <div v-else>
            <div>
                <label class="search-inpt" for="searchInput">Search:</label>
                <input v-model="searchQuery" id="searchInput" type="text" @input="filterItems" class="search" />
            </div>
            <div class="employees-table">
                <table v-if="filteredItems.length > 0">
                    <thead>
                        <tr>
                            <th>PassData</th>
                            <th>Degree</th>
                            <th>Specialization</th>
                            <th>Position</th>
                            <th>Salary</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="employee in filteredItems" :key="employee.id">
                            <td>{{ employee.passData }}</td>
                            <td>{{ employee.degree }}</td>
                            <td>{{ employee.specialization }}</td>
                            <td>{{ employee.position }}</td>
                            <td>{{ employee.salary }}</td>
                            <td><button class="button primary" @click="goToDetailsPage(employee.id)">Edit</button></td>
                        </tr>
                    </tbody>
                </table>
                <p v-else class="no-employees-message">No employees found.</p>
            </div>
        </div>
    </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
    name: 'EmployeesCardsList',
    data() {
        return {
            searchQuery: '',
        };
    },
    computed: {
        ...mapGetters('employees', ['getItemsList', 'isLoading', 'getFilter']),
        filteredItems() {
            const filter = this.getFilter;
            const searchResults = this.getItemsList.filter((employee) => {
                return (
                    (!filter.passData || employee.passData.toString().toLowerCase().includes(filter.passData.toLowerCase())) &&
                    (!filter.degree || employee.degree.toLowerCase().includes(filter.degree.toLowerCase())) &&
                    (!filter.specialization || employee.specialization.toLowerCase().includes(filter.specialization.toLowerCase())) &&
                    (!filter.position || employee.position.toLowerCase().includes(filter.position.toLowerCase())) &&
                    (!filter.salary || employee.salary.toString().toLowerCase().includes(filter.salary.toLowerCase())) &&
                    (Object.values(employee).some((value) => String(value).toLowerCase().includes(this.searchQuery.toLowerCase())))
                );
            });

            return searchResults;
        },
    },
    created() {
        this.loadList();
    },
    methods: {
        ...mapActions('employees', ['loadList']),
        goToDetailsPage(employeeId) {
            this.$router.push({ name: 'config', params: { itemId: employeeId } });
        },
    },
};
</script>

<style lang="scss" scoped>
.employees-table {
    margin-top: 20px;
}

table {
    width: 100%;
    border-collapse: collapse;
    margin-top: 10px;
}

th,
td {
    border: 1px solid #ddd;
    padding: 8px;
    text-align: left;
}

th {
    background-color: #f2f2f2;
    color: black;
}

.no-employees-message {
    font-size: 16px;
    color: white;
}

.button {
    padding: 10px;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    font-weight: bold;
    transition: background-color 0.3s ease;
}

.button.primary {
    background-color: #3498db;
    color: #fff;
}

.button.danger {
    background-color: #e74c3c;
    color: #fff;
}

.search {
    background-color: white;
    padding: 10px;
    border: 1px solid darkorange;
    border-radius: 5px;
    cursor: pointer;
    font-weight: bold;
}

.search-inpt {
    font-size: 200%;
}
</style>
